"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __reExport = (target, mod, secondTarget) => (__copyProps(target, mod, "default"), secondTarget && __copyProps(secondTarget, mod, "default"));
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.tsx
var src_exports = {};
__export(src_exports, {
  WixProvider: () => WixProvider,
  useEnvironment: () => useEnvironment,
  useWix: () => useWix,
  useWixAuth: () => useWixAuth,
  useWixFetch: () => useWixFetch,
  useWixFetchWithAuth: () => useWixFetchWithAuth,
  useWixModules: () => useWixModules
});
module.exports = __toCommonJS(src_exports);
var import_sdk = require("@wix/sdk");
var React = __toESM(require("react"), 1);
var import_react = require("react");
__reExport(src_exports, require("@wix/sdk"), module.exports);
var WixContext = (0, import_react.createContext)(void 0);
var HostEnvironmentContext = (0, import_react.createContext)(void 0);
function WixProvider(props) {
  const { children, auth, modules, host } = props;
  const client = (0, import_react.useMemo)(
    () => (0, import_sdk.createClient)({
      auth,
      modules,
      host
    }),
    [auth, modules, host]
  );
  return /* @__PURE__ */ React.createElement(WixContext.Provider, { value: client }, host ? /* @__PURE__ */ React.createElement(HostEnvironmentProvider, { host }, children) : children);
}
function HostEnvironmentProvider(props) {
  const [environment, setEnvironment] = React.useState(null);
  (0, import_react.useEffect)(() => {
    if (props.host.environment) {
      setEnvironment(props.host.environment);
    } else if (props.host.channel) {
      const handle = props.host.channel.observeState(
        (_, env) => setEnvironment(env)
      );
      return () => {
        Promise.resolve(handle).then((h) => h.disconnect());
      };
    }
  }, [props.host.environment, props.host.channel]);
  if (!environment) {
    return null;
  }
  return /* @__PURE__ */ React.createElement(HostEnvironmentContext.Provider, { value: environment }, props.children);
}
function useWix() {
  const sdk = React.useContext(WixContext);
  if (!sdk) {
    throw new Error(
      "SDK context not found. Make sure to render SDKProvider in the component tree"
    );
  }
  return sdk;
}
function useWixFetch() {
  const sdk = useWix();
  return sdk.fetch;
}
function useWixFetchWithAuth() {
  const sdk = useWix();
  return sdk.fetchWithAuth;
}
function useWixAuth() {
  const sdk = useWix();
  return sdk.auth;
}
function useWixModules(modules) {
  const sdk = useWix();
  return (0, import_react.useMemo)(() => sdk.use(modules), [sdk, modules]);
}
function useEnvironment() {
  const environment = React.useContext(HostEnvironmentContext);
  if (!environment) {
    throw new Error(
      "Host environment context not found. Make sure to render SDKProvider in the component tree and provide a host parameter"
    );
  }
  return environment;
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  WixProvider,
  useEnvironment,
  useWix,
  useWixAuth,
  useWixFetch,
  useWixFetchWithAuth,
  useWixModules,
  ...require("@wix/sdk")
});
