import { Host, Descriptors, AuthenticationStrategy, AssertHostMatches, WixClient, BoundAuthenticationStrategy, BuildDescriptors } from '@wix/sdk';
export * from '@wix/sdk';
import * as React from 'react';

declare function WixProvider<H extends Host<any> | undefined = undefined, T extends Descriptors = Descriptors>(props: React.PropsWithChildren<{
    auth?: AuthenticationStrategy<H>;
    modules?: H extends Host<any> ? AssertHostMatches<T, H> : T;
    host?: H;
}>): React.JSX.Element;
declare function useWix<T extends WixClient<Host<any> | undefined> = WixClient>(): T;
/**
 * @deprecated please use `useWixFetchWithAuth()` instead
 * @returns fetch
 */
declare function useWixFetch(): (relativeUrl: string, options: RequestInit) => Promise<Response>;
declare function useWixFetchWithAuth(): typeof fetch;
declare function useWixAuth<T extends AuthenticationStrategy>(): Omit<T, "getAuthHeaders"> & BoundAuthenticationStrategy;
declare function useWixModules<T extends Descriptors>(modules: T): BuildDescriptors<T, Host<any>>;
declare function useEnvironment<T>(): T;

export { WixProvider, useEnvironment, useWix, useWixAuth, useWixFetch, useWixFetchWithAuth, useWixModules };
